diff --git a/gcc/config.in b/gcc/config.in
index 18e627141cc..7a3e003f8ac 100644
--- a/gcc/config.in
+++ b/gcc/config.in
@@ -1640,6 +1640,12 @@
 #endif
 
 
+/* Define to 1 if your linker supports -z indirect-extern-access */
+#ifndef USED_FOR_TARGET
+#undef HAVE_LD_INDIRECT_EXTERN_ACCESS_SUPPORT
+#endif
+
+
 /* Define if your PowerPC64 linker supports a large TOC. */
 #ifndef USED_FOR_TARGET
 #undef HAVE_LD_LARGE_TOC
diff --git a/gcc/config/i386/gnu-property.c b/gcc/config/i386/gnu-property.c
index 4ba04403002..9fe8d00132e 100644
--- a/gcc/config/i386/gnu-property.c
+++ b/gcc/config/i386/gnu-property.c
@@ -24,37 +24,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "output.h"
 #include "linux-common.h"
 
-static void
-emit_gnu_property (unsigned int type, unsigned int data)
-{
-  int p2align = ptr_mode == SImode ? 2 : 3;
-
-  switch_to_section (get_section (".note.gnu.property",
-				  SECTION_NOTYPE, NULL));
-
-  ASM_OUTPUT_ALIGN (asm_out_file, p2align);
-  /* name length.  */
-  fprintf (asm_out_file, ASM_LONG "1f - 0f\n");
-  /* data length.  */
-  fprintf (asm_out_file, ASM_LONG "4f - 1f\n");
-  /* note type: NT_GNU_PROPERTY_TYPE_0.  */
-  fprintf (asm_out_file, ASM_LONG "5\n");
-  fprintf (asm_out_file, "0:\n");
-  /* vendor name: "GNU".  */
-  fprintf (asm_out_file, STRING_ASM_OP "\"GNU\"\n");
-  fprintf (asm_out_file, "1:\n");
-  ASM_OUTPUT_ALIGN (asm_out_file, p2align);
-  /* pr_type.  */
-  fprintf (asm_out_file, ASM_LONG "0x%x\n", type);
-  /* pr_datasz.  */
-  fprintf (asm_out_file, ASM_LONG "3f - 2f\n");
-  fprintf (asm_out_file, "2:\n");
-  fprintf (asm_out_file, ASM_LONG "0x%x\n", data);
-  fprintf (asm_out_file, "3:\n");
-  ASM_OUTPUT_ALIGN (asm_out_file, p2align);
-  fprintf (asm_out_file, "4:\n");
-}
-
 void
 file_end_indicate_exec_stack_and_gnu_property (void)
 {
diff --git a/gcc/config/i386/i386.c b/gcc/config/i386/i386.c
index 4ab85cc4fe0..8e86781299e 100644
--- a/gcc/config/i386/i386.c
+++ b/gcc/config/i386/i386.c
@@ -24042,6 +24042,8 @@ ix86_run_selftests (void)
 #if !TARGET_MACHO && !TARGET_DLLIMPORT_DECL_ATTRIBUTES
 # undef TARGET_ASM_RELOC_RW_MASK
 # define TARGET_ASM_RELOC_RW_MASK ix86_reloc_rw_mask
+# undef TARGET_ASM_EMIT_GNU_PROPERTY_NOTE
+# define TARGET_ASM_EMIT_GNU_PROPERTY_NOTE emit_gnu_property_note
 #endif
 
 static bool ix86_libc_has_fast_function (int fcode ATTRIBUTE_UNUSED)
diff --git a/gcc/configure b/gcc/configure
index f0b2ebde3cf..1b92dd803ca 100755
--- a/gcc/configure
+++ b/gcc/configure
@@ -32177,6 +32177,30 @@ fi
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ld_bndplt_support" >&5
 $as_echo "$ld_bndplt_support" >&6; }
 
+# Check linker supports '-z indirect-extern-access'
+ld_indirect_extern_access=0
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking linker -z indirect-extern-access option" >&5
+$as_echo_n "checking linker -z indirect-extern-access option... " >&6; }
+if test x"$ld_is_gold" = xno; then
+  if test $in_tree_ld = yes ; then
+    if test "$gcc_cv_gld_major_version" -eq 2 -a "$gcc_cv_gld_minor_version" -ge 37 -o "$gcc_cv_gld_major_version" -gt 2; then
+      ld_indirect_extern_access=1
+    fi
+  elif test x$gcc_cv_ld != x; then
+    # Check if linker supports -z indirect-extern-access option
+    if $gcc_cv_ld --help 2>&1 | grep -- '-z indirect-extern-access' > /dev/null; then
+      ld_indirect_extern_access=1
+    fi
+  fi
+fi
+
+cat >>confdefs.h <<_ACEOF
+#define HAVE_LD_INDIRECT_EXTERN_ACCESS_SUPPORT $ld_indirect_extern_access
+_ACEOF
+
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ld_indirect_extern_access" >&5
+$as_echo "$ld_indirect_extern_access" >&6; }
+
 # Check linker supports '--push-state'/'--pop-state'
 ld_pushpopstate_support=no
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking linker --push-state/--pop-state options" >&5
diff --git a/gcc/configure.ac b/gcc/configure.ac
index 70089394429..aa905efe4e9 100644
--- a/gcc/configure.ac
+++ b/gcc/configure.ac
@@ -7483,6 +7483,26 @@ if test x"$ld_bndplt_support" = xyes; then
 fi
 AC_MSG_RESULT($ld_bndplt_support)
 
+# Check linker supports '-z indirect-extern-access'
+ld_indirect_extern_access=0
+AC_MSG_CHECKING(linker -z indirect-extern-access option)
+if test x"$ld_is_gold" = xno; then
+  if test $in_tree_ld = yes ; then
+    if test "$gcc_cv_gld_major_version" -eq 2 -a "$gcc_cv_gld_minor_version" -ge 37 -o "$gcc_cv_gld_major_version" -gt 2; then
+      ld_indirect_extern_access=1
+    fi
+  elif test x$gcc_cv_ld != x; then
+    # Check if linker supports -z indirect-extern-access option
+    if $gcc_cv_ld --help 2>&1 | grep -- '-z indirect-extern-access' > /dev/null; then
+      ld_indirect_extern_access=1
+    fi
+  fi
+fi
+AC_DEFINE_UNQUOTED(HAVE_LD_INDIRECT_EXTERN_ACCESS_SUPPORT,
+	$ld_indirect_extern_access,
+	[Define to 1 if your linker supports -z indirect-extern-access])
+AC_MSG_RESULT($ld_indirect_extern_access)
+
 # Check linker supports '--push-state'/'--pop-state'
 ld_pushpopstate_support=no
 AC_MSG_CHECKING(linker --push-state/--pop-state options)
diff --git a/gcc/doc/tm.texi b/gcc/doc/tm.texi
index 2a41ae5fba1..5b1f5c135b0 100644
--- a/gcc/doc/tm.texi
+++ b/gcc/doc/tm.texi
@@ -8073,6 +8073,11 @@ Output to @code{asm_out_file} any text which the assembler expects
 to find at the end of a file.  The default is to output nothing.
 @end deftypefn
 
+@deftypefn {Target Hook} void TARGET_ASM_EMIT_GNU_PROPERTY_NOTE (void)
+Output a GNU property note to @code{asm_out_file}.  The default is to
+output nothing.
+@end deftypefn
+
 @deftypefun void file_end_indicate_exec_stack ()
 Some systems use a common convention, the @samp{.note.GNU-stack}
 special section, to indicate whether or not an object file relies on
diff --git a/gcc/doc/tm.texi.in b/gcc/doc/tm.texi.in
index f881cdabe9e..7091e02ca81 100644
--- a/gcc/doc/tm.texi.in
+++ b/gcc/doc/tm.texi.in
@@ -5050,6 +5050,8 @@ This describes the overall framework of an assembly file.
 
 @hook TARGET_ASM_FILE_END
 
+@hook TARGET_ASM_EMIT_GNU_PROPERTY_NOTE
+
 @deftypefun void file_end_indicate_exec_stack ()
 Some systems use a common convention, the @samp{.note.GNU-stack}
 special section, to indicate whether or not an object file relies on
diff --git a/gcc/output.h b/gcc/output.h
index 73ca4545f4f..f9cbf7cab37 100644
--- a/gcc/output.h
+++ b/gcc/output.h
@@ -607,6 +607,8 @@ extern void default_asm_declare_constant_name (FILE *, const char *,
 extern void default_file_start (void);
 extern void file_end_indicate_exec_stack (void);
 extern void file_end_indicate_split_stack (void);
+extern void emit_gnu_property (unsigned int, unsigned int);
+extern void emit_gnu_property_note (void);
 
 extern void default_elf_asm_output_external (FILE *file, tree,
 					     const char *);
diff --git a/gcc/target.def b/gcc/target.def
index c009671c583..31e8bc0ab97 100644
--- a/gcc/target.def
+++ b/gcc/target.def
@@ -715,6 +715,14 @@ to find at the end of a file.  The default is to output nothing.",
  void, (void),
  hook_void_void)
 
+/* Output a GNU property note.  */
+DEFHOOK
+(emit_gnu_property_note,
+ "Output a GNU property note to @code{asm_out_file}.  The default is to\n\
+output nothing.",
+ void, (void),
+ hook_void_void)
+
 /* Output any boilerplate text needed at the beginning of an
    LTO output stream.  */
 DEFHOOK
diff --git a/gcc/toplev.c b/gcc/toplev.c
index 55e7550151f..bddcfdf5bde 100644
--- a/gcc/toplev.c
+++ b/gcc/toplev.c
@@ -585,6 +585,9 @@ compile_file (void)
   /* Invoke registered plugin callbacks.  */
   invoke_plugin_callbacks (PLUGIN_FINISH_UNIT, NULL);
 
+  /* Output a GNU property note.  */
+  targetm.asm_out.emit_gnu_property_note ();
+
   /* This must be at the end.  Some target ports emit end of file directives
      into the assembly file here, and hence we cannot output anything to the
      assembly file after this point.  */
diff --git a/gcc/varasm.c b/gcc/varasm.c
index 53cf6dea3f3..b0850864534 100644
--- a/gcc/varasm.c
+++ b/gcc/varasm.c
@@ -7729,6 +7729,53 @@ default_file_start (void)
     }
 }
 
+/* Emit one GNU property of TYPE and DATA.  */
+
+void
+emit_gnu_property (unsigned int type, unsigned int data)
+{
+  int p2align = ptr_mode == SImode ? 2 : 3;
+
+  switch_to_section (get_section (".note.gnu.property",
+				  SECTION_NOTYPE, NULL));
+
+  ASM_OUTPUT_ALIGN (asm_out_file, p2align);
+  /* name length.  */
+  fprintf (asm_out_file, ASM_LONG "1f - 0f\n");
+  /* data length.  */
+  fprintf (asm_out_file, ASM_LONG "4f - 1f\n");
+  /* note type: NT_GNU_PROPERTY_TYPE_0.  */
+  fprintf (asm_out_file, ASM_LONG "5\n");
+  fprintf (asm_out_file, "0:\n");
+  /* vendor name: "GNU".  */
+  fprintf (asm_out_file, STRING_ASM_OP "\"GNU\"\n");
+  fprintf (asm_out_file, "1:\n");
+  ASM_OUTPUT_ALIGN (asm_out_file, p2align);
+  /* pr_type.  */
+  fprintf (asm_out_file, ASM_LONG "0x%x\n", type);
+  /* pr_datasz.  */
+  fprintf (asm_out_file, ASM_LONG "3f - 2f\n");
+  fprintf (asm_out_file, "2:\n");
+  fprintf (asm_out_file, ASM_LONG "0x%x\n", data);
+  fprintf (asm_out_file, "3:\n");
+  ASM_OUTPUT_ALIGN (asm_out_file, p2align);
+  fprintf (asm_out_file, "4:\n");
+}
+
+/* This is a generic routine for TARGET_ASM_EMIT_GNU_PROPERTY_NOTE to
+   emit a NT_GNU_PROPERTY_TYPE_0 note.  This is primarily a GNU extension
+   to ELF but could be used on other targets.  */
+
+void
+emit_gnu_property_note (void)
+{
+  if (HAVE_LD_INDIRECT_EXTERN_ACCESS_SUPPORT
+      && !flag_direct_extern_access)
+    /* Emite a GNU_PROPERTY_1_NEEDED note with
+       GNU_PROPERTY_1_NEEDED_INDIRECT_EXTERN_ACCESS.  */
+    emit_gnu_property (0xb0008000, (1U << 0));
+}
+
 /* This is a generic routine suitable for use as TARGET_ASM_FILE_END
    which emits a special section directive used to indicate whether or
    not this object file needs an executable stack.  This is primarily